diff --git a/sys/contrib/dev/acpica/source/compiler/aslresources.y b/sys/contrib/dev/acpica/source/compiler/aslresources.y
index 92d58a9..34ce475 100644
--- a/sys/contrib/dev/acpica/source/compiler/aslresources.y
+++ b/sys/contrib/dev/acpica/source/compiler/aslresources.y
@@ -718,8 +790,9 @@ WordSpaceTerm
         OptionalByteConstExpr
         OptionalStringData
         OptionalNameString_Last
-        ')'                         {$$ = TrLinkChildren ($<n>3,14,
+        PARSEOP_CLOSE_PAREN         {$$ = TrLinkChildren ($<n>3,14,
                                         $4,$6,$7,$8,$9,$11,$13,$15,$17,$19,$21,$22,$23,$24);}
-    | PARSEOP_WORDSPACE '('
-        error ')'                   {$$ = AslDoError(); yyclearin;}
+    | PARSEOP_WORDSPACE
+        PARSEOP_OPEN_PAREN
+        error PARSEOP_CLOSE_PAREN   {$$ = AslDoError(); yyclearin;}
     ;
diff --git a/sys/contrib/dev/acpica/source/compiler/aslrestype2.c b/sys/contrib/dev/acpica/source/compiler/aslrestype2.c
index b75c118..bc130e5 100644
--- a/sys/contrib/dev/acpica/source/compiler/aslrestype2.c
+++ b/sys/contrib/dev/acpica/source/compiler/aslrestype2.c
@@ -127,6 +127,11 @@ RsDoGeneralRegisterDescriptor (
             RsCreateByteField (InitializerOp, ACPI_RESTAG_ACCESSSIZE,
                 CurrentByteOffset + ASL_RESDESC_OFFSET (GenericReg.AccessSize));
 
+            if (Descriptor->GenericReg.AddressSpaceId == ACPI_ADR_SPACE_PLATFORM_COMM)
+            {
+                break;
+            }
+
             if (Descriptor->GenericReg.AccessSize > AML_FIELD_ACCESS_QWORD)
             {
                 AslError (ASL_ERROR, ASL_MSG_INVALID_ACCESS_SIZE,
diff --git a/sys/contrib/dev/acpica/source/compiler/aslrules.y b/sys/contrib/dev/acpica/source/compiler/aslrules.y
index 2cb972f..112f041 100644
--- a/sys/contrib/dev/acpica/source/compiler/aslrules.y
+++ b/sys/contrib/dev/acpica/source/compiler/aslrules.y
@@ -81,14 +81,15 @@ AslCode
  * The ObjectList term is obsolete and has been removed.
  */
 DefinitionBlockTerm
-    : PARSEOP_DEFINITION_BLOCK '('  {$<n>$ = TrCreateLeafNode (PARSEOP_DEFINITION_BLOCK);}
+    : PARSEOP_DEFINITION_BLOCK
+        PARSEOP_OPEN_PAREN          {$<n>$ = TrCreateLeafNode (PARSEOP_DEFINITION_BLOCK);}
         String ','
         String ','
         ByteConst ','
         String ','
         String ','
         DWordConst
-        ')'                         {TrSetEndLineNumber ($<n>3);}
+        PARSEOP_CLOSE_PAREN         {TrSetEndLineNumber ($<n>3);}
             '{' TermList '}'        {$$ = TrLinkChildren ($<n>3,7,
                                         $4,$6,$8,$10,$12,$14,$18);}
     ;
@@ -99,6 +100,9 @@ DefinitionBlockList
         DefinitionBlockList         {$$ = TrLinkPeerNodes (2, $1,$2);}
     ;
 
+
+/******* Basic ASCII identifiers **************************************************/
+
 /* Allow IO, DMA, IRQ Resource macro and FOR macro names to also be used as identifiers */
 
 NameString
@@ -112,20 +116,31 @@ NameString
 /*
 NameSeg
     : PARSEOP_NAMESEG               {$$ = TrCreateValuedLeafNode (PARSEOP_NAMESEG, (ACPI_NATIVE_INT)
-                                            TrNormalizeNameSeg ($1));}
+                                        TrNormalizeNameSeg ($1));}
     ;
 */
 
 NameSeg
     : PARSEOP_NAMESEG               {$$ = TrCreateValuedLeafNode (PARSEOP_NAMESEG,
-                                            (ACPI_NATIVE_INT) AslCompilerlval.s);}
+                                        (ACPI_NATIVE_INT) AslCompilerlval.s);}
     ;
 
 
+/******* Fundamental argument/statement types ***********************************/
+
+Term
+    : Object                        {}
+    | Type1Opcode                   {}
+    | Type2Opcode                   {}
+    | Type2IntegerOpcode            {$$ = TrSetNodeFlags ($1, NODE_COMPILE_TIME_CONST);}
+    | Type2StringOpcode             {$$ = TrSetNodeFlags ($1, NODE_COMPILE_TIME_CONST);}
+    | Type2BufferOpcode             {}
+    | Type2BufferOrStringOpcode     {}
+    | error                         {$$ = AslDoError(); yyclearin;}
+    ;
+
 SuperName
-    : NameString                    {}
-    | ArgTerm                       {}
-    | LocalTerm                     {}
+    : SimpleName                    {}
     | DebugTerm                     {}
     | Type6Opcode                   {}
     ;
@@ -136,14 +151,19 @@ Target
     | ',' SuperName                 {$$ = TrSetNodeFlags ($2, NODE_IS_TARGET);}
     ;
 
+RequiredTarget
+    : ',' SuperName                 {$$ = TrSetNodeFlags ($2, NODE_IS_TARGET);}
+    ;
+
 TermArg
-    : Type2Opcode                   {$$ = TrSetNodeFlags ($1, NODE_IS_TERM_ARG);}
+    : SimpleName                    {$$ = TrSetNodeFlags ($1, NODE_IS_TERM_ARG);}
+    | Type2Opcode                   {$$ = TrSetNodeFlags ($1, NODE_IS_TERM_ARG);}
     | DataObject                    {$$ = TrSetNodeFlags ($1, NODE_IS_TERM_ARG);}
-    | NameString                    {$$ = TrSetNodeFlags ($1, NODE_IS_TERM_ARG);}
-    | ArgTerm                       {$$ = TrSetNodeFlags ($1, NODE_IS_TERM_ARG);}
-    | LocalTerm                     {$$ = TrSetNodeFlags ($1, NODE_IS_TERM_ARG);}
-
-
+/*
+    | PARSEOP_OPEN_PAREN
+        TermArg
+        PARSEOP_CLOSE_PAREN         {}
+*/
     ;
 
 /*
@@ -156,8 +176,10 @@ TermArg
 */
 
 MethodInvocationTerm
-    : NameString '('                {TrUpdateNode (PARSEOP_METHODCALL, $1);}
-        ArgList ')'                 {$$ = TrLinkChildNode ($1,$4);}
+    : NameString
+        PARSEOP_OPEN_PAREN          {TrUpdateNode (PARSEOP_METHODCALL, $1);}
+        ArgList
+        PARSEOP_CLOSE_PAREN         {$$ = TrLinkChildNode ($1,$4);}
     ;
 
 /* OptionalCount must appear before ByteList or an incorrect reduction will result */
@@ -176,23 +198,44 @@ OptionalDataCount
 
         /* Legacy ASL */
     :                               {$$ = NULL;}
-    | '(' TermArg ')'               {$$ = $2;}
-    | '('  ')'                      {$$ = NULL;}
+    | PARSEOP_OPEN_PAREN
+        TermArg
+        PARSEOP_CLOSE_PAREN         {$$ = $2;}
+    | PARSEOP_OPEN_PAREN
+        PARSEOP_CLOSE_PAREN         {$$ = NULL;}
 
         /* C-style (ASL+) -- adds equals term */
 
     |  PARSEOP_EXP_EQUALS           {$$ = NULL;}
 
-    | '(' TermArg ')'
+    | PARSEOP_OPEN_PAREN
+        TermArg
+        PARSEOP_CLOSE_PAREN
         PARSEOP_EXP_EQUALS          {$$ = $2;}
 
-    | '('  ')' String
+    | PARSEOP_OPEN_PAREN
+        PARSEOP_CLOSE_PAREN
+        String
         PARSEOP_EXP_EQUALS          {$$ = NULL;}
     ;
 
 
 /******* List Terms **************************************************/
 
+    /* ACPI 3.0 -- allow semicolons between terms */
+
+TermList
+    :                               {$$ = NULL;}
+    | TermList Term                 {$$ = TrLinkPeerNode (
+                                        TrSetNodeFlags ($1, NODE_RESULT_NOT_USED),$2);}
+    | TermList Term ';'             {$$ = TrLinkPeerNode (
+                                        TrSetNodeFlags ($1, NODE_RESULT_NOT_USED),$2);}
+    | TermList ';' Term             {$$ = TrLinkPeerNode (
+                                        TrSetNodeFlags ($1, NODE_RESULT_NOT_USED),$3);}
+    | TermList ';' Term ';'         {$$ = TrLinkPeerNode (
+                                        TrSetNodeFlags ($1, NODE_RESULT_NOT_USED),$3);}
+    ;
+
 ArgList
     :                               {$$ = NULL;}
     | TermArg
@@ -299,38 +342,13 @@ OptionalParameterTypesPackage
                                         TrCreateLeafNode (PARSEOP_DEFAULT_ARG),1,$2);}
     ;
 
-    /* ACPI 3.0 -- allow semicolons between terms */
-
-TermList
-    :                               {$$ = NULL;}
-    | TermList Term                 {$$ = TrLinkPeerNode (
-                                        TrSetNodeFlags ($1, NODE_RESULT_NOT_USED),$2);}
-    | TermList Term ';'             {$$ = TrLinkPeerNode (
-                                        TrSetNodeFlags ($1, NODE_RESULT_NOT_USED),$2);}
-    | TermList ';' Term             {$$ = TrLinkPeerNode (
-                                        TrSetNodeFlags ($1, NODE_RESULT_NOT_USED),$3);}
-    | TermList ';' Term ';'         {$$ = TrLinkPeerNode (
-                                        TrSetNodeFlags ($1, NODE_RESULT_NOT_USED),$3);}
-    ;
-
-Term
-    : Object                        {}
-    | Type1Opcode                   {}
-    | Type2Opcode                   {}
-    | Type2IntegerOpcode            {$$ = TrSetNodeFlags ($1, NODE_COMPILE_TIME_CONST);}
-    | Type2StringOpcode             {$$ = TrSetNodeFlags ($1, NODE_COMPILE_TIME_CONST);}
-    | Type2BufferOpcode             {}
-    | Type2BufferOrStringOpcode     {}
-    | error                         {$$ = AslDoError(); yyclearin;}
-    ;
-
 /*
  * Case-Default list; allow only one Default term and unlimited Case terms
  */
 CaseDefaultTermList
     :                               {$$ = NULL;}
-    | CaseTerm  {}
-    | DefaultTerm   {}
+    | CaseTerm                      {}
+    | DefaultTerm                   {}
     | CaseDefaultTermList
         CaseTerm                    {$$ = TrLinkPeerNode ($1,$2);}
     | CaseDefaultTermList
@@ -520,32 +538,59 @@ NameSpaceModifier
     | ScopeTerm                     {}
     ;
 
-/* For ObjectType: SuperName except for MethodInvocationTerm */
-
-ObjectTypeName
+SimpleName
     : NameString                    {}
-    | ArgTerm                       {}
     | LocalTerm                     {}
+    | ArgTerm                       {}
+    ;
+
+/* For ObjectType(), SuperName except for MethodInvocationTerm */
+
+ObjectTypeSource
+    : SimpleName                    {}
     | DebugTerm                     {}
     | RefOfTerm                     {}
     | DerefOfTerm                   {}
     | IndexTerm                     {}
     | IndexExpTerm                  {}
-/*    | MethodInvocationTerm          {} */  /* Caused reduce/reduce with Type6Opcode->MethodInvocationTerm */
     ;
 
-RequiredTarget
-    : ',' SuperName                 {$$ = TrSetNodeFlags ($2, NODE_IS_TARGET);}
+/* For DeRefOf(), SuperName except for DerefOf and Debug */
+
+DerefOfSource
+    : SimpleName                    {}
+    | RefOfTerm                     {}
+    | DerefOfTerm                   {}
+    | IndexTerm                     {}
+    | IndexExpTerm                  {}
+    | StoreTerm                     {}
+    | EqualsTerm                    {}
+    | MethodInvocationTerm          {}
     ;
 
-SimpleTarget
-    : NameString                    {}
-    | LocalTerm                     {}
-    | ArgTerm                       {}
+/* For RefOf(), SuperName except for RefOf and MethodInvocationTerm */
+
+RefOfSource
+    : SimpleName                    {}
+    | DebugTerm                     {}
+    | DerefOfTerm                   {}
+    | IndexTerm                     {}
+    | IndexExpTerm                  {}
     ;
 
-/* Opcode types */
+/* For CondRefOf(), SuperName except for RefOf and MethodInvocationTerm */
+
+CondRefOfSource
+    : SimpleName                    {}
+    | DebugTerm                     {}
+    | DerefOfTerm                   {}
+    | IndexTerm                     {}
+    | IndexExpTerm                  {}
+    ;
 
+/*
+ * Opcode types, as defined in the ACPI specification
+ */
 Type1Opcode
     : BreakTerm                     {}
     | BreakPointTerm                {}
diff --git a/sys/contrib/dev/acpica/source/compiler/aslstubs.c b/sys/contrib/dev/acpica/source/compiler/aslstubs.c
index b88513f..c472e07 100644
--- a/sys/contrib/dev/acpica/source/compiler/aslstubs.c
+++ b/sys/contrib/dev/acpica/source/compiler/aslstubs.c
@@ -188,8 +188,7 @@ AcpiEvReleaseGlobalLock (
 
 ACPI_STATUS
 AcpiEvInitializeRegion (
-    ACPI_OPERAND_OBJECT     *RegionObj,
-    BOOLEAN                 AcpiNsLocked)
+    ACPI_OPERAND_OBJECT     *RegionObj)
 {
     return (AE_OK);
 }
diff --git a/sys/contrib/dev/acpica/source/compiler/asltokens.y b/sys/contrib/dev/acpica/source/compiler/asltokens.y
index ff1dd42..61213db 100644
--- a/sys/contrib/dev/acpica/source/compiler/asltokens.y
+++ b/sys/contrib/dev/acpica/source/compiler/asltokens.y
@@ -465,6 +465,9 @@ NoEcho('
 %left <i>  PARSEOP_EXP_INCREMENT
            PARSEOP_EXP_DECREMENT
 
+%left <i>  PARSEOP_OPEN_PAREN
+           PARSEOP_CLOSE_PAREN
+
 /* Brackets for Index() support */
 
 %left <i>  PARSEOP_EXP_INDEX_LEFT
diff --git a/sys/contrib/dev/acpica/source/compiler/asltypes.y b/sys/contrib/dev/acpica/source/compiler/asltypes.y
index 1152a42..d463997 100644
--- a/sys/contrib/dev/acpica/source/compiler/asltypes.y
+++ b/sys/contrib/dev/acpica/source/compiler/asltypes.y
@@ -68,7 +68,7 @@ NoEcho('
 %type <n> ParameterTypesPackage
 %type <n> ParameterTypesPackageList
 %type <n> RequiredTarget
-%type <n> SimpleTarget
+%type <n> SimpleName
 %type <n> StringData
 %type <n> Target
 %type <n> Term
@@ -252,7 +252,10 @@ NoEcho('
 /* Types */
 
 %type <n> SuperName
-%type <n> ObjectTypeName
+%type <n> ObjectTypeSource
+%type <n> DerefOfSource
+%type <n> RefOfSource
+%type <n> CondRefOfSource
 %type <n> ArgTerm
 %type <n> LocalTerm
 %type <n> DebugTerm
diff --git a/sys/contrib/dev/acpica/source/compiler/aslwalks.c b/sys/contrib/dev/acpica/source/compiler/aslwalks.c
index 357b92d..9fbc582 100644
--- a/sys/contrib/dev/acpica/source/compiler/aslwalks.c
+++ b/sys/contrib/dev/acpica/source/compiler/aslwalks.c
@@ -862,21 +862,10 @@ AnAnalyzeStoreOperator (
     case PARSEOP_DEREFOF:
     case PARSEOP_REFOF:
     case PARSEOP_INDEX:
+    case PARSEOP_STORE:
 
         return;
 
-    case PARSEOP_METHODCALL:
-        /*
-         * A target is not allowed to be a method call.
-         * It is not supported by the ACPICA interpreter, nor is it
-         * supported by the MS ASL compiler or the MS interpreter.
-         * Although legal syntax up until ACPI 6.1, support for this
-         * will be removed for ACPI 6.2 (02/2016)
-         */
-        AslError (ASL_ERROR, ASL_MSG_SYNTAX,
-            TargetOperandOp, "Illegal method invocation as a target operand");
-        return;
-
     default:
         break;
     }
diff --git a/sys/contrib/dev/acpica/source/compiler/dttable.c b/sys/contrib/dev/acpica/source/compiler/dttable.c
index c1011f8..7b33e4d 100644
--- a/sys/contrib/dev/acpica/source/compiler/dttable.c
+++ b/sys/contrib/dev/acpica/source/compiler/dttable.c
@@ -129,12 +129,9 @@ DtCompileFadt (
     DT_SUBTABLE             *ParentTable;
     DT_FIELD                **PFieldList = (DT_FIELD **) List;
     ACPI_TABLE_HEADER       *Table;
-    UINT8                   FadtRevision;
-    UINT32                  i;
+    UINT8                   Revision;
 
 
-    /* Minimum table is the FADT version 1 (ACPI 1.0) */
-
     Status = DtCompileTable (PFieldList, AcpiDmTableInfoFadt1,
         &Subtable, TRUE);
     if (ACPI_FAILURE (Status))
@@ -146,41 +143,22 @@ DtCompileFadt (
     DtInsertSubtable (ParentTable, Subtable);
 
     Table = ACPI_CAST_PTR (ACPI_TABLE_HEADER, ParentTable->Buffer);
-    FadtRevision = Table->Revision;
-
-    /* Revision 0 and 2 are illegal */
-
-    if ((FadtRevision == 0) ||
-        (FadtRevision == 2))
-    {
-        DtError (ASL_ERROR, 0, NULL,
-            "Invalid value for FADT revision");
-
-        return (AE_BAD_VALUE);
-    }
-
-    /* Revision out of supported range? */
+    Revision = Table->Revision;
 
-    if (FadtRevision > ACPI_FADT_MAX_VERSION)
+    if (Revision == 2)
     {
-        DtError (ASL_ERROR, 0, NULL,
-            "Unknown or unsupported value for FADT revision");
-
-        return (AE_BAD_VALUE);
-    }
-
-    /* Compile individual sub-parts of the FADT, per-revision */
-
-    for (i = 3; i <= ACPI_FADT_MAX_VERSION; i++)
-    {
-        if (i > FadtRevision)
+        Status = DtCompileTable (PFieldList, AcpiDmTableInfoFadt2,
+            &Subtable, TRUE);
+        if (ACPI_FAILURE (Status))
         {
-            break;
+            return (Status);
         }
 
-        /* Compile the fields specific to this FADT revision */
-
-        Status = DtCompileTable (PFieldList, FadtRevisionInfo[i],
+        DtInsertSubtable (ParentTable, Subtable);
+    }
+    else if (Revision >= 2)
+    {
+        Status = DtCompileTable (PFieldList, AcpiDmTableInfoFadt3,
             &Subtable, TRUE);
         if (ACPI_FAILURE (Status))
         {
@@ -188,6 +166,30 @@ DtCompileFadt (
         }
 
         DtInsertSubtable (ParentTable, Subtable);
+
+        if (Revision >= 5)
+        {
+            Status = DtCompileTable (PFieldList, AcpiDmTableInfoFadt5,
+                &Subtable, TRUE);
+            if (ACPI_FAILURE (Status))
+            {
+                return (Status);
+            }
+
+            DtInsertSubtable (ParentTable, Subtable);
+        }
+
+        if (Revision >= 6)
+        {
+            Status = DtCompileTable (PFieldList, AcpiDmTableInfoFadt6,
+                &Subtable, TRUE);
+            if (ACPI_FAILURE (Status))
+            {
+                return (Status);
+            }
+
+            DtInsertSubtable (ParentTable, Subtable);
+        }
     }
 
     return (AE_OK);
diff --git a/sys/contrib/dev/acpica/source/components/disassembler/dmbuffer.c b/sys/contrib/dev/acpica/source/components/disassembler/dmbuffer.c
index 694df66..1393982 100644
--- a/sys/contrib/dev/acpica/source/components/disassembler/dmbuffer.c
+++ b/sys/contrib/dev/acpica/source/components/disassembler/dmbuffer.c
@@ -441,12 +441,16 @@ AcpiDmIsUnicodeBuffer (
         return (FALSE);
     }
 
-    /* For each word, 1st byte must be ascii (1-0x7F), 2nd byte must be zero */
-
+    /*
+     * For each word, 1st byte must be printable ascii, and the
+     * 2nd byte must be zero. This does not allow for escape
+     * sequences, but it is the most secure way to detect a
+     * unicode string.
+     */
     for (i = 0; i < (ByteCount - 2); i += 2)
     {
         if ((ByteData[i] == 0) ||
-            (ByteData[i] > 0x7F) ||
+            !(isprint (ByteData[i])) ||
             (ByteData[(ACPI_SIZE) i + 1] != 0))
         {
             return (FALSE);
@@ -509,12 +513,27 @@ AcpiDmIsStringBuffer (
         return (FALSE);
     }
 
+    /*
+     * Check for a possible standalone resource EndTag, ignore it
+     * here. However, this sequence is also the string "Y", but
+     * this seems rare enough to be acceptable.
+     */
+    if ((ByteCount == 2) && (ByteData[0] == 0x79))
+    {
+        return (FALSE);
+    }
+
+    /* Check all bytes for ASCII */
+
     for (i = 0; i < (ByteCount - 1); i++)
     {
-        /* TBD: allow some escapes (non-ascii chars).
+        /*
+         * TBD: allow some escapes (non-ascii chars).
          * they will be handled in the string output routine
          */
 
+        /* Not a string if not printable ascii */
+
         if (!isprint (ByteData[i]))
         {
             return (FALSE);
